﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Ext.Net;

namespace SoftCo
{
    public partial class Login : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                using (SoftCoEntities db = new SoftCoEntities())
                {
                    var roles = db.Role.OrderBy(p => p.DisplayIndex);
                    foreach (var role in roles)
                    {
                        cboRoles.Items.Add(new Ext.Net.ListItem(role.RoleName, role.RoleCode));
                    }
                    cboRoles.SelectedItem.Value = "OrdinaryUsers";
                }
            }
        }

        protected void btnSubmit_Click(object sender, DirectEventArgs e)
        {
            if (cboRoles.SelectedItem == null || string.IsNullOrEmpty(cboRoles.SelectedItem.Value))
            {
                X.MessageBox.Alert("温馨提示", "请选择角色！").Show();
                return;
            }
            else if (txtPassword.Text.Trim() == string.Empty)
            {
                X.MessageBox.Alert("温馨提示", "请输入密码！！").Show();
                return;
            }
            else
            {
                if (cboRoles.SelectedItem.Value == "OrdinaryUsers" && txtCardID.Text.Trim().Length == 0)
                {
                    X.MessageBox.Alert("温馨提示", "请输入卡号！！").Show();
                    return;
                }
                else if (cboRoles.SelectedItem.Value == "Administrator" && txtUserName.Text.Trim().Length == 0)
                {
                    X.MessageBox.Alert("温馨提示", "请输入用户名！！").Show();
                    return;
                }
                X.Redirect("/Index.aspx", "登陆成功，正在为您加载个人主页...");
            }

        }
    }
}