﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Ext.Net;

namespace SoftCo
{
    /// <summary>
    /// 操作Code枚举
    /// </summary>
    public enum FACodeEnum
    {
        /// <summary>
        /// 取消
        /// </summary>
        Cancel,
        /// <summary>
        /// 保存
        /// </summary>
        Save,
        /// <summary>
        /// 新建
        /// </summary>
        New,
        /// <summary>
        /// 退回
        /// </summary>
        Reject,
        /// <summary>
        /// 等待
        /// </summary>
        Wait,
        /// <summary>
        /// 通知
        /// </summary>
        Notice,
        /// <summary>
        /// 编辑
        /// </summary>
        Edit,
        /// <summary>
        /// 提交
        /// </summary>
        Submit,
        /// <summary>
        /// 同意
        /// </summary>
        Approve,
        /// <summary>
        /// 撤销
        /// </summary>
        Repeal
    }
    public partial class WorkbenchMain : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                SetButton(Icon.Cancel, "取消", FACodeEnum.Cancel, Toolbar1, "GridPanel1");
                SetButton(Icon.Cancel, "取消", FACodeEnum.Cancel, tbButtons, "GridPanel6");
                SetButton(Icon.PageSave, "保存", FACodeEnum.Save, Toolbar1, "GridPanel1");
                SetButton(Icon.PageSave, "保存", FACodeEnum.Save, tbButtons, "GridPanel6");
                SetButton(Icon.PageBack, "退回", FACodeEnum.Reject, Toolbar1, "GridPanel1");
                SetButton(Icon.PageBack, "退回", FACodeEnum.Reject, tbButtons, "GridPanel6");
                SetButton(Icon.PackageGo, "等待", FACodeEnum.Wait, Toolbar1, "GridPanel1");
                SetButton(Icon.PackageGo, "等待", FACodeEnum.Wait, tbButtons, "GridPanel6");
                SetButton(Icon.NoteGo, "通知", FACodeEnum.Notice, Toolbar1, "GridPanel1");
                SetButton(Icon.NoteGo, "通知", FACodeEnum.Notice, tbButtons, "GridPanel6");
                SetButton(Icon.PageAdd, "提交", FACodeEnum.Submit, Toolbar1, "GridPanel1");
                SetButton(Icon.PageAdd, "提交", FACodeEnum.Submit, tbButtons, "GridPanel6");
                SetButton(Icon.Accept, "同意", FACodeEnum.Approve, Toolbar1, "GridPanel1");
                SetButton(Icon.PageAdd, "同意", FACodeEnum.Approve, tbButtons, "GridPanel6");
                foreach (var item in ButtonGroup1.Items)
                {
                    if (item is Ext.Net.Button)
                    {
                        (item as Ext.Net.Button).Listeners.Click.Fn = "showTestPage";
                    }
                }
            }
        }

        /// <summary>
        /// 向工具条添加按钮
        /// </summary>
        /// <param name="icon">图标</param>
        /// <param name="text">文本</param>
        /// <param name="facode">操作Code</param>
        /// <param name="toolbar">工具条</param>
        /// <param name="_panelName">容器ID</param>
        private static void SetButton(Icon icon, string text, FACodeEnum facode, Toolbar toolbar, string _panelName)
        {
            if (toolbar == null) throw new ArgumentNullException("toolbar");
            var _btn = new Ext.Net.Button
            {
                Icon = icon,
                Text = text,
                Listeners =
                {
                    Click =
                    {
                        Handler =
                            string.Format("toExcuteOperations(#{{{0}}}.getSelectionModel().getSelections(),'{1}');", _panelName, facode.ToString())
                    }
                }
            };
            //设置Click事件的Handler，用于操作所选项。操作参数（所选记录集、操作Code）
            if (toolbar.Items.Count > 0)
                toolbar.Items.Add(new ToolbarSeparator());
            toolbar.Items.Add(_btn);
        }

    }
}